<?php
add_action( 'admin_init', 'tchannel_settings_init' );


function tchannel_settings_init(  ) { 

	register_setting( 'channelPage', 'tchannel_settings' );

	add_settings_section(
		'tchannel_pluginPage_section', 
		__( 'Get Telegram API ready', 'tchannel' ), 
		'tchannel_settings_section_callback', 
		'channelPage'
	);

	add_settings_field( 
		'tchannel_text_token', 
		__( 'Enter Your Telegram Bot Token', 'tchannel' ), 
		'tchannel_text_token_render', 
		'channelPage', 
		'tchannel_pluginPage_section' 
	);
	add_settings_field( 
		'tchannel_log', 
		__( 'Log Your Activity?', 'tchannel' ), 
		'tchannel_log_render', 
		'channelPage', 
		'tchannel_pluginPage_section' 
	);
	add_settings_field( 
		'tchannel_channels', 
		__( 'List of Channels', 'tchannel' ), 
		'tchannel_channels_render', 
		'channelPage', 
		'tchannel_pluginPage_section' 
	);
	add_settings_field( 
		'tchannel_groups', 
		__( 'List of Groups', 'tchannel' ), 
		'tchannel_groups_render', 
		'channelPage', 
		'tchannel_pluginPage_section' 
	);
	
$args = array(
   'public'   => true
);
$output = 'names'; // names or objects, note names is the default
$operator = 'and'; // 'and' or 'or'
$post_types = get_post_types( $args, $output, $operator ); 
foreach ( $post_types  as $post_type ) {
	if ($post_type == 'attachment' || $post_type == 'subscriber') {} else {
	add_settings_field( 
		'tbt_'.$post_type, 
		__( 'Send Notification for ', 'tchannel' ).$post_type, 
		'tchannel_post_types_render', 
		'channelPage', 
		'tchannel_pluginPage_section',
array( 'type' => $post_type )		
	);
	}
}

}

function tchannel_text_token_render(  ) { 
	$options = get_option( 'tchannel_settings' );
	?>
	<input size="60" style='direction:ltr;' type='text' name='tchannel_settings[tchannel_text_token]' value='<?php echo $options['tchannel_text_token']; ?>'>
	<?php

}
function tchannel_log_render(  ) { 

	$options = get_option( 'tchannel_settings' );
	?>
	<select name='tchannel_settings[tchannel_log]'>
		<option value='yes' <?php selected( $options['tchannel_log'], 'yes' ); ?>><?php printf(__( 'Yes', 'tchannel' )); ?></option>
		<option value='no' <?php selected( $options['tchannel_log'], 'no' ); ?>><?php printf(__( 'No', 'tchannel' )); ?></option>
	</select>

<?php

}
function tchannel_channels_render(  ) { 
	$options = get_option( 'tchannel_settings' );
	?>
	<textarea style='direction:ltr;' cols='70' rows='5' name='tchannel_settings[tchannel_channels]'><?php echo $options['tchannel_channels']; ?></textarea>
	<p><?php printf(__( 'Please write down Channel IDs separated by "+" including @ (ex: @websimaca+@webasimachannel2)', 'tchannel' )); ?></p>
	<?php
}
function tchannel_groups_render(  ) { 
	$options = get_option( 'tchannel_settings' );
	?>
	<textarea style='direction:ltr;' cols='70' rows='5' name='tchannel_settings[tchannel_groups]'><?php echo $options['tchannel_groups']; ?></textarea>
	<p><?php printf(__( 'Please write down Group IDs and Names separated by "/" and make theme separated by + (ex: -56894843/websimaGroup+-78894843/samplegroup2)', 'tchannel' )); ?></p>
	<?php
}
function tchannel_post_types_render( $type ) { 
$type = $type['type'];
	$options = get_option( 'tchannel_settings' );
	?>
	<input type='checkbox' name='tchannel_settings[tchannel_<?php echo $type; ?>]' <?php checked( $options['tchannel_'.$type], $type ); ?> value='<?php echo $type; ?>'>
	<label><?php echo $type; ?></label>
	<?php
}

function tchannel_settings_section_callback(  ) { 

	echo __( 'Before updating this settings please read the Documents carefully', 'tchannel' );

}


function channeller_options_page(  ) { 

	?>
	<form action='options.php' method='post'>
				<style>
		a.websimabanner {
			right:5%;left:auto;position: absolute;
		}
		body.rtl a.websimabanner {
			left: 5%;right:auto
		}
		</style>
		<h2><?php printf(__( 'Telegram Channel Admin', 'tchannel' )); ?></h2>
		<a class="websimabanner" href="http://websima.com/channeller" title="websima channeller"><img width="281" height="364" src="<?php echo plugins_url( 'channeller.png', __FILE__ ); ?>" alt="وبسیما تلتر"/></a>
		<?php
		settings_fields( 'channelPage' );
		do_settings_sections( 'channelPage' );
		submit_button();
		?>
		
	</form>
	<?php } ?>